<script setup>
    import { ref, onMounted, inject } from 'vue'
    import CreateLectionDiagol from '../components/CreateLectionDialog.vue'
    import NavBar from '../components/NavBar.vue'
    import { useRoute  } from 'vue-router'
    const axios = inject('axios')
    const dayjs = inject('dayjs')  // inject axios
    const route = useRoute()
    const lections = ref([])
    const tempLections = ref([])
    const dialogOpen = ref(false)
    const historyLection = ref(false)

    onMounted(() => {
      getLection()
      });


    function getLection(){
      axios.get(`${localStorage.getItem("username")}/lections/${localStorage.getItem("jwt")}`)
        .then(function(response) {
          if (response.status === 200) {
            lections.value = response.data
            tempLections.value= lections.value.filter((lection)=>dayjs().isBefore(dayjs(lection.start_time)))
          }
        })
      }

    function deleteLection(lectionId){
      axios.delete(`${localStorage.getItem("username")}/lections/${localStorage.getItem("jwt")}`)
      .then(function(response){
        if (response.status === 200) {
          getLection()
          console.log(lectionId)
        }
      })
      
    }

    function onToggleDialog() {
      dialogOpen.value = !dialogOpen.value
    }

    function onToggleHistory() {
      historyLection.value = !historyLection.value
      if(historyLection.value){
        tempLections.value= lections.value.filter((lection)=>dayjs().isAfter(dayjs(lection.start_time)))
      }else{
        tempLections.value= lections.value.filter((lection)=>dayjs().isBefore(dayjs(lection.start_time)))
      }
    }
    
</script>

<template>
  <NavBar></NavBar>
  <header class="bg-slate-50">
    <div class="mx-auto max-w-7xl px-4 py-6 sm:px-6 lg:px-8">
      <h1 class="text-3xl font-bold tracking-tight text-gray-900 text-center">Lections</h1>
    </div>
  </header>
  <main>
    <Transition>
        <CreateLectionDiagol v-if="dialogOpen" v-model="dialogOpen" @submit_success="getLection"></CreateLectionDiagol>
      </Transition>
      <div class="pt-4 px-8">
        <button @click="onToggleDialog()" type="button" class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-4 py-2 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">Add Lection</button>
      </div>
      <div>
          <ul class="flex flex-wrap text-sm font-medium text-center text-gray-500 dark:text-gray-400 pt-4 px-8">
            <li class="me-2">
                <a
                @click="onToggleHistory"
                :class="{'bg-blue-600 active text-white': !historyLection, 
                            'hover:text-gray-900 hover:bg-gray-100':historyLection}"
                            
                class="inline-block px-4 py-3 rounded-lg ">Upcoming</a>
            </li>
            <li class="me-2"
            >
                <a 
                @click="onToggleHistory"
                :class="{'bg-blue-600 active text-white': historyLection, 
                            'hover:text-gray-900 hover:bg-gray-100':!historyLection}"
                class="inline-block px-4 py-3 rounded-lg ">History</a>
            </li>
          </ul>
        </div>
        <div class="py-4 px-8">
          <table v-if="lections.length" class="w-full text-sm text-left rtl:text-right text-gray-500 ">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                <tr>
                    <th scope="col" class="px-6 py-3">
                        Lection Name
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Description
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Room
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Date and Time
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Capacity
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Action
                    </th>
                </tr>
            </thead>
            <tbody>
            <tr v-for="lection in tempLections"
            
            class="bg-white border-b">
                <th scope="row" class="flex items-center px-6 py-4 text-gray-900 whitespace-nowrap dark:text-white">
                    <div class="ps-3">
                        <div class="text-base font-semibold ">{{lection.name}}</div>
                    </div>  
                </th>
                <td class="px-6 py-4">
                    <div class="flex items-center">
                        {{lection.description}}
                    </div>
                </td>
                <td class="px-6 py-4 ">
                    {{lection.room_name}}
                </td>
                <td class="px-6 py-4">
                  <p class="font-semibold">
                    {{ dayjs(lection.start_time).format('DD.MM.YYYY')}}
                  </p>
                  <p>
                    {{dayjs(lection.start_time).format('H:mm') + ' - ' + dayjs(lection.end_time).format('H:mm')  }}
                  </p>
                  
                </td>
                <td class="px-6 py-4">
                {{lection.clients + ' / ' + lection.max_capacity}}
                </td>
                <td class="px-6 py-4">
                  <button 
                  :class="{'bg-gray-100 fill-gray-600':historyLection,
                            'fill-rose-600 hover:fill-rose-800 hover:bg-rose-200' : !historyLection}"
                  :disabled="historyLection" @click="deleteLection(lection.id)" class="p-2 w-8 h-8 rounded-md">
                    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512">
                    <path d="M170.5 51.6L151.5 80h145l-19-28.4c-1.5-2.2-4-3.6-6.7-3.6H177.1c-2.7 0-5.2 1.3-6.7 3.6zm147-26.6L354.2 80H368h48 8c13.3 0 24 10.7 24 24s-10.7 24-24 24h-8V432c0 44.2-35.8 80-80 80H112c-44.2 0-80-35.8-80-80V128H24c-13.3 0-24-10.7-24-24S10.7 80 24 80h8H80 93.8l36.7-55.1C140.9 9.4 158.4 0 177.1 0h93.7c18.7 0 36.2 9.4 46.6 24.9zM80 128V432c0 17.7 14.3 32 32 32H336c17.7 0 32-14.3 32-32V128H80zm80 64V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16zm80 0V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16zm80 0V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16z"/>
                  </svg>
                  </button>
                </td>
            </tr>
        </tbody>
          </table>
          <div v-if="!lections.length" class="p-4 my-4 text-sm text-yellow-800 rounded-lg bg-yellow-50">
            <span class="font-medium">Info </span> You have no training. Please create one.
        </div>
        </div>

  </main>
</template>

<style>
  .v-enter-active,
  .v-leave-active {
  transition: opacity 0.5s ease;
}

  .v-enter-from,
  .v-leave-to {
  opacity: 0;
}

</style>